﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using HealthyHitsujiWpf.Model.Dao.Xml;
using HealthyHitsujiWpf.Model.DataBase;
using HitsujiLibrary201004.Utils.Date;

namespace HealthyHitsujiWpf.Model.Content
{
    public class MonthContentsModel : List<_IContentModel>, _IContentModel
    {
                
        //データベースの一日あたりのデータ取得
        public DateContentsModel getField(int dayIndex)
        {
            DateContentsModel fieldModel = UiModelFactry.createDateContentsModel();
            try
            {
                foreach (DateContentsModel dateData in this)
                {
                    if (dateData.DateId.Equals(dayIndex.ToString()))
                    {
                        fieldModel = dateData;
                        break;
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return fieldModel;
        }


        //一ヶ月あたりのデータを取得
        public void getMonthData(StringBuilder dataBaseFilePath, int year, int month, int day)
        {
            
            try
            {
                var selectMonthDataDao = new SelectMonthDataXmlDao().getData(dataBaseFilePath);
                DataTable table = selectMonthDataDao.Tables[MonthDataBaseColumnModel.dataTableName_];

                foreach (DataRow row in table.Rows)
                {

                    //データ読み込み
                    DateContentsModel record = UiModelFactry.createDateContentsModelAsMonthDataMember();

                    record.Year = year;
                    record.Month = month;
                    record.Day = int.Parse(row.Field<string>(MonthDataBaseColumnModel.day_));
                    record.SelectedDateLabel = new DateTime(record.Year,
                                                            record.Month,
                                                            record.Day).ToString("yyyy/MM/dd");

                    record.DateId = row.Field<string>(MonthDataBaseColumnModel.day_);
                    record.calAm = row.Field<string>(MonthDataBaseColumnModel.am_);
                    record.calNoon = row.Field<string>(MonthDataBaseColumnModel.noon_);
                    record.calPm = row.Field<string>(MonthDataBaseColumnModel.pm_);
                    record.calOther = row.Field<string>(MonthDataBaseColumnModel.other_);
                    record.calBurn = row.Field<string>(MonthDataBaseColumnModel.burn_);
                    record.balanceGrain = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balGrain_));
                    record.balanceMeat = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balMeat_));
                    record.balanceSeafood = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balSeafood_));
                    record.balanceVegetable = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balVegetable_));
                    record.balanceFruit = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balFruit_));
                    record.balanceDairy = Boolean.Parse(row.Field<string>(MonthDataBaseColumnModel.balDairy_));
                    record.walkCount = row.Field<string>(MonthDataBaseColumnModel.walk_);
                    record.heightCm = row.Field<string>(MonthDataBaseColumnModel.cm_);
                    record.weightKg = row.Field<string>(MonthDataBaseColumnModel.kg_);
                    record.memo = row.Field<string>(MonthDataBaseColumnModel.memo_);

                    this.Add(record);
                }

                table.Rows.Clear();

                table.Clear();
                table = null;
                selectMonthDataDao.Tables.Remove(MonthDataBaseColumnModel.dataTableName_);
                selectMonthDataDao.Tables.Clear();
                selectMonthDataDao.Clear();
                selectMonthDataDao = null;

            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
            finally
            {
                
            }
        }


        //デフォルトデータ生成
        /// <summary>
        /// すべてのフィールドが初期値を有する月分データ
        /// </summary>
        /// <param name="year"></param>
        /// <param name="month"></param>
        /// <param name="day"></param>
        public void getDefaultMonthData(int year, int month, int day)
        {
            try
            {
                for (int dayCount = 1; dayCount <= HDateCountUtil.getDateCount(year, month); dayCount++)
                {
                    DateContentsModel record = UiModelFactry.createDateContentsModelAsMonthDataMember();

                    record.Year = year;
                    record.Month = month;
                    record.Day = dayCount;
                    record.SelectedDateLabel = new DateTime(record.Year,
                                                            record.Month,
                                                            record.Day).ToString("yyyy/MM/dd");

                    record.DateId = dayCount.ToString();
                    record.calAm ="0";
                    record.calNoon = "0";
                    record.calPm = "0";
                    record.calOther = "0";
                    record.calBurn = "0";
                    record.balanceGrain = false;
                    record.balanceMeat = false;
                    record.balanceSeafood = false;
                    record.balanceVegetable = false;
                    record.balanceFruit = false;
                    record.balanceDairy = false;
                    record.walkCount = "0";
                    record.heightCm = "0.0";
                    record.weightKg = "0.0";
                    record.memo = "";

                    this.Add(record);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

    }
}
