﻿using System;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.ObserverPattern.Observer;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HitsujiLibrary201004.Utils.Thread;

namespace HealthyHitsujiWpf.Model.View
{
    public class CalendarViewModel : _AViewModel
    {

        public CalendarViewModel()
        {
            SelectedDateData = UiModelFactry.createSelectedDateModel();
            SelectedDateData.canExeDelegate_ = this.canChangeSelectedDate;
            SelectedDateData.exeDelegate_ = this.OnSelectedDateChanged;
        }


        public SelectedDateModel SelectedDateData
        {
            get;
            set;
        }


        #region ▼選択日付更新コマンド関連

        //選択日付更新の許可チェック
        public Boolean canChangeSelectedDate()
        {
            return true;
        }

        //選択日付更新処理
        public void OnSelectedDateChanged()
        {
            try
            {
                using (var threadPrepare = new PrepareThreadUtil())
                {
                    //【サブジェクト、オブザーバを生成】
                    GetSelectedMonthDataSubject selectMonthDataSubject = new GetSelectedMonthDataSubject();
                    ReflectUiEntryObserver entryObserver = new ReflectUiEntryObserver();
                    ReflectUiMonthDataListBoxObserver monthDataListBoxObserver = new ReflectUiMonthDataListBoxObserver();

                    //【各オブザーバに更新対象のUI参照を設定】
                    entryObserver.setRefViewModel(this.parentVM_.getViewModelMember("EntryViewModel"));
                    monthDataListBoxObserver.setRefViewModel(this.parentVM_.getViewModelMember("MonthDataListBoxViewModel"));

                    //【サブジェクトにモデル、オブザーバを設定】
                    selectMonthDataSubject.models.Add(SelectedDateData.GetType().Name, SelectedDateData);
                    selectMonthDataSubject.addObserver(entryObserver);
                    selectMonthDataSubject.addObserver(monthDataListBoxObserver);

                    threadPrepare.prepare("Thread-SelectDateInfo", selectMonthDataSubject.doMyRole);
                    threadPrepare.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion ▲選択日付更新コマンド関連

    }
}
