﻿using System;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HealthyHitsujiWpf.ObserverPattern.Observer;
using HealthyHitsujiWpf.Model.Content;
using HitsujiLibrary201004.ObserverPattern.Observer;

namespace HealthyHitsujiWpf.Model.View
{
    public class EntryViewModel : _AViewModel
    {

        #region ▼コンストラクタ

        public EntryViewModel()
        {
            this.DateContentsInfo = UiModelFactry.createDateContentsModel();
            DateContentsInfo.canExeDelegate_ = this.checkNessesaryPropertyValues;
            DateContentsInfo.exeDelegate_ = this.updateMonthDataXmlFile;
            
        }

        #endregion ▲コンストラクタ


        #region ▼プロパティ

        public String id_ = null;

        public DateContentsModel DateContentsInfo
        {
            get;
            set;
        }

        #endregion ▲プロパティ


        #region ▼データ更新ボタン処理関連

        //一ヶ月あたりのデータファイル（XML）を生成
        public void updateMonthDataXmlFile()
        {
            //_AHitsujiSubject updateDbMonthDataSubject = new UpdateDbMonthDataSubject();
            _AHitsujiSubject updateDbMonthDataSubject = new GetSelectedMonthDataSubject();
            _IObserver createXmlFileObserver = new CreateXmlFileObserver();
            var selectedDateInfo = UiModelFactry.createSelectedDateModel();
            
            try
            {
                selectedDateInfo.SelectedDate = new DateTime(DateContentsInfo.Year,
                                                             DateContentsInfo.Month,
                                                             DateContentsInfo.Day);
                updateDbMonthDataSubject.models.Add(selectedDateInfo.GetType().Name, selectedDateInfo);
                updateDbMonthDataSubject.models.Add(DateContentsInfo.GetType().Name, DateContentsInfo);
                updateDbMonthDataSubject.addObserver(createXmlFileObserver);

                updateDbMonthDataSubject.doMyRole();

                //表示更新のため、強制的に選択日付を更新
                this.notifyDataBaseUpdated();
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
            finally
            {
                selectedDateInfo = null;
                createXmlFileObserver = null;
                updateDbMonthDataSubject.models.Clear();
                updateDbMonthDataSubject = null;
            }
        }

        //必須項目の入力値チェック
        public bool checkNessesaryPropertyValues()
        {
            int intTypeDefaultValue = 0;
            double dblTypeDefaultValue = 0.0;
            if (int.TryParse(this.DateContentsInfo.calAm, out intTypeDefaultValue) &&
                int.TryParse(this.DateContentsInfo.calNoon, out intTypeDefaultValue) &&
                int.TryParse(this.DateContentsInfo.calPm, out intTypeDefaultValue) &&
                int.TryParse(this.DateContentsInfo.calOther, out intTypeDefaultValue) &&
                int.TryParse(this.DateContentsInfo.calBurn, out intTypeDefaultValue) &&
                int.TryParse(this.DateContentsInfo.walkCount, out intTypeDefaultValue) &&
                double.TryParse(this.DateContentsInfo.heightCm, out dblTypeDefaultValue) &&
                double.TryParse(this.DateContentsInfo.weightKg, out dblTypeDefaultValue))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        //データベース更新後、更新したことをカレンダーに通知する
        protected void notifyDataBaseUpdated()
        {
            try
            {
                //System.Threading.Thread.Sleep(200);
                var calendarVM = (CalendarViewModel)this.parentVM_.getViewModelMember("CalendarViewModel");
                calendarVM.SelectedDateData.SelectedDate = new DateTime(this.DateContentsInfo.Year,
                                                                        this.DateContentsInfo.Month,
                                                                        this.DateContentsInfo.Day);
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion ▲データ更新ボタン処理関連

    }
}
