﻿using System;
using HealthyHitsujiWpf.Command;
using System.IO;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.DataBase;
using HealthyHitsujiWpf.Model.OutPutFileSetterModel;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HealthyHitsujiWpf.ObserverPattern.Observer;
using HitsujiLibrary201004.Utils.Thread;

namespace HealthyHitsujiWpf.Model.View
{
    public class OutPutViewModel : _AViewModel
    {

        #region ▼コマンドプロパティ

        private _ADirectCommand onClickedOutPutMonthDataAsCsvCommand_;
        public _ADirectCommand OnClickedOutPutMonthDataAsCsvCommand
        {
            get { return onClickedOutPutMonthDataAsCsvCommand_; }
            set { onClickedOutPutMonthDataAsCsvCommand_ = value; }
        }

        #endregion ▲コマンドプロパティ


        #region ▼コンストラクタ

        public OutPutViewModel()
        {
            
        }

        #endregion ▲コンストラクタ


        #region ▼コマンド処理関連

        public bool canOutPutMonthDataAsCsv(object param)
        {
            var calendarVM = (CalendarViewModel)parentVM_.getViewModelMember("CalendarViewModel");
            var year = calendarVM.SelectedDateData.SelectedDate.Year;
            var month = calendarVM.SelectedDateData.SelectedDate.Month;
            var day = calendarVM.SelectedDateData.SelectedDate.Day;

            if (File.Exists(MonthDataBaseFile.buildDataBaseFilePath(year, month).ToString()))
            {
                return true;
            }
            else
            {
                String msg = "当月のデータが存在しないため、データファイルを出力できませんでした。";
                Console.WriteLine(msg);
                System.Windows.MessageBox.Show(msg);
                return false;
            }
        }


        public void executeOutPutMonthDataAsCsv(object param)
        {
            try
            {
                using (var threadPrepare = new PrepareThreadUtil())
                {
                    var calendarVM = (CalendarViewModel)parentVM_.getViewModelMember("CalendarViewModel");
                    var selectedDateInfo = (SelectedDateModel)calendarVM.SelectedDateData;
                    var getSelectedMonthDataSubject = new GetSelectedMonthDataSubject();
                    var outPutDataObserver = new OutPutMonthDataAsCsvFileObserver();

                    _IOutPutCsvFileSetterModel outPutInfoSetter = (_IOutPutCsvFileSetterModel)param;
                    //出力ファイルパス設定
                    //outPutDataObserver.setOutPutFilePath(outPutInfoSetter.getOutPutFilePath(selectedDateInfo));
                    //出力対象カラム設定
                    outPutDataObserver.targetColumnSelectionDelegate = outPutInfoSetter.buildColumnSelectionDelegate();
                    //出力対象情報フィールド設定
                    outPutDataObserver.targetFieldSelectionDelegate = outPutInfoSetter.buildFieldSelectionDelegate();

                    getSelectedMonthDataSubject.models.Add(selectedDateInfo.GetType().Name, selectedDateInfo);
                    getSelectedMonthDataSubject.addObserver(outPutDataObserver);

                    threadPrepare.prepare("Thread-OutputCsvFile", getSelectedMonthDataSubject.doMyRole);
                    threadPrepare.threadStart();
                }
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion ▲コマンド処理関連

    }
}
