﻿using System;
using HealthyHitsujiWpf.Model.DataBase;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HitsujiLibrary201004.Utils.Data;
using HitsujiLibrary201004.ObserverPattern.Subject;
using HitsujiLibrary201004.ObserverPattern.Observer;
using HealthyHitsujiWpf.Model.Content;

namespace HealthyHitsujiWpf.ObserverPattern.Observer
{
    public class CreateXmlFileObserver : _IObserver
    {

        #region _IObserver メンバ

        public void doMyRole(_ASubject subj)
        {
            try
            {
                //_AHitsujiSubject subject = subj as UpdateDbMonthDataSubject;
                _AHitsujiSubject subject = subj as GetSelectedMonthDataSubject;
                var selectedDateInfo = (SelectedDateModel)subject.models["SelectedDateModel"];
                var dateContentsInfo = (DateContentsModel)subject.models["DateContentsModel"];
                var monthContentsinfo = (MonthContentsModel)subject.models["MonthContentsModel"];

                HDataSet tempDataSet = new HDataSet();
                MonthDataBaseColumnModel.buildDataBaseColumn(tempDataSet);

                var year = selectedDateInfo.SelectedDate.Year;
                var month = selectedDateInfo.SelectedDate.Month;

                for (int dayId = 1; dayId <= monthContentsinfo.Count; dayId++)
                {
                    DateContentsModel d = monthContentsinfo.getField(dayId);
                    if (dayId == selectedDateInfo.SelectedDate.Day)
                    {
                        d = dateContentsInfo;
                    }
                    else
                    {
                        d = monthContentsinfo.getField(dayId);
                    }

                    var myTable = tempDataSet.Tables[MonthDataBaseColumnModel.dataTableName_];
                    var myRow = myTable.NewRow();
                    myRow[MonthDataBaseColumnModel.day_] = dayId.ToString();
                    myRow[MonthDataBaseColumnModel.am_] = d.calAm;
                    myRow[MonthDataBaseColumnModel.noon_] = d.calNoon;
                    myRow[MonthDataBaseColumnModel.pm_] = d.calPm;
                    myRow[MonthDataBaseColumnModel.other_] = d.calOther;
                    myRow[MonthDataBaseColumnModel.balGrain_] = d.balanceGrain;
                    myRow[MonthDataBaseColumnModel.balMeat_] = d.balanceMeat;
                    myRow[MonthDataBaseColumnModel.balSeafood_] = d.balanceSeafood;
                    myRow[MonthDataBaseColumnModel.balVegetable_] = d.balanceVegetable;
                    myRow[MonthDataBaseColumnModel.balFruit_] = d.balanceFruit;
                    myRow[MonthDataBaseColumnModel.balDairy_] = d.balanceDairy;
                    myRow[MonthDataBaseColumnModel.burn_] = d.calBurn;
                    myRow[MonthDataBaseColumnModel.walk_] = d.walkCount;
                    myRow[MonthDataBaseColumnModel.cm_] = d.heightCm;
                    myRow[MonthDataBaseColumnModel.kg_] = d.weightKg;
                    myRow[MonthDataBaseColumnModel.memo_] = d.memo;
                    myTable.Rows.Add(myRow);
                }

                
                tempDataSet.WriteXml(MonthDataBaseFile.buildDataBaseFilePath(year, month).ToString());
                tempDataSet.Clear();
                tempDataSet = null;

            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion
    }
}
