﻿using System;
using System.Collections.Generic;
using System.Windows.Documents;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.View;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HitsujiLibrary201004.ObserverPattern.Observer;
using HitsujiLibrary201004.ObserverPattern.Subject;

namespace HealthyHitsujiWpf.ObserverPattern.Observer
{
    public class ReflectUiEntryObserver : _IObserver, _IReflectUiObserver
    {
        
        #region _IObserver メンバ

        public void doMyRole(_ASubject s)
        {
            try
            {
                _AHitsujiSubject subject = (s as GetSelectedMonthDataSubject);
                var selectedDateInfo = (SelectedDateModel)subject.models["SelectedDateModel"];
                var monthContentsInfo = (MonthContentsModel)subject.models["MonthContentsModel"];

                DateContentsModel record = monthContentsInfo.getField(selectedDateInfo.SelectedDate.Day);
                
                List<Action> dispatchActionList = new List<Action>();


                dispatchActionList.Add(delegate()
                { 
                    entryViewModel_.DateContentsInfo.SelectedDateLabel = record.SelectedDateLabel;
                    entryViewModel_.DateContentsInfo.Year = selectedDateInfo.SelectedDate.Year;
                    entryViewModel_.DateContentsInfo.Month = selectedDateInfo.SelectedDate.Month;
                    entryViewModel_.DateContentsInfo.Day = selectedDateInfo.SelectedDate.Day;
                    entryViewModel_.DateContentsInfo.calAm = record.calAm;
                    entryViewModel_.DateContentsInfo.calNoon = record.calNoon;
                    entryViewModel_.DateContentsInfo.calPm = record.calPm;
                    entryViewModel_.DateContentsInfo.calOther = record.calOther;
                    entryViewModel_.DateContentsInfo.calBurn = record.calBurn;

                    entryViewModel_.DateContentsInfo.balanceGrain = record.balanceGrain;
                    entryViewModel_.DateContentsInfo.balanceMeat = record.balanceMeat;
                    entryViewModel_.DateContentsInfo.balanceSeafood = record.balanceSeafood;
                    entryViewModel_.DateContentsInfo.balanceVegetable = record.balanceVegetable;
                    entryViewModel_.DateContentsInfo.balanceFruit = record.balanceFruit;
                    entryViewModel_.DateContentsInfo.balanceDairy = record.balanceDairy;

                    entryViewModel_.DateContentsInfo.walkCount = record.walkCount.ToString();
                    entryViewModel_.DateContentsInfo.heightCm = record.heightCm.ToString();
                    entryViewModel_.DateContentsInfo.weightKg = record.weightKg.ToString();

                    entryViewModel_.DateContentsInfo.memo = record.memo;

                });

                //処理実行
                this.reflectUi(dispatchActionList);
                
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
        }

        #endregion

        public void reflectUi(List<Action> dispatchActionList)
        {
            try
            {
                foreach (Action act in dispatchActionList)
                {
                    entryViewModel_.BaseUiWindow.Dispatcher.Invoke(act);
                }
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
        }


        #region _IReflectUiObserver メンバ

        private HealthyHitsujiWpf.Model.View.EntryViewModel entryViewModel_ = null;
        public void setRefViewModel(_AViewModel vm)
        {
            entryViewModel_ = (vm as HealthyHitsujiWpf.Model.View.EntryViewModel);
        }

        #endregion

    }
}
