﻿using System;
using System.IO;
using System.Text;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.DataBase;
using HitsujiLibrary201004.Utils.Date;

namespace HealthyHitsujiWpf.ObserverPattern.Subject
{
    public class UpdateDbMonthDataSubject : _AHitsujiSubject
    {

        public override void doMyRole()
        {
            base.models.Add("MonthContentsModel", new MonthContentsModel());
            SelectedDateModel selectedDateInfo = (SelectedDateModel)base.models["SelectedDateModel"];

            var year = selectedDateInfo.SelectedDate.Year;
            var month = selectedDateInfo.SelectedDate.Month;
            var day = selectedDateInfo.SelectedDate.Day;
            var dateCountOfMonth = HDateCountUtil.getDateCount(year, month);
            //var tempFilePath = MonthDataBaseFile.buildTempDataBaseFile(); //一時ファイルのパス
            //データベースのファイルパス
            var filePathBuilder = MonthDataBaseFile.buildDataBaseFilePath(year, month);

            try
            {
                //ディレクトリの存在確認（ない場合は作成）
                if (!Directory.Exists(MonthDataBaseFile.getDirectoryPath_AsMonthData().ToString()))
                {
                    Directory.CreateDirectory(MonthDataBaseFile.getDirectoryPath_AsMonthData().ToString());
                    System.Threading.Thread.Sleep(200);
                }

                
                //データファイルの存在確認
                if (!File.Exists(filePathBuilder.ToString()))
                {
                    //データ読み込み（データファイルが存在しない場合）
                    (models["MonthContentsModel"] as MonthContentsModel).getDefaultMonthData(selectedDateInfo.SelectedDate.Year,
                                                                                             selectedDateInfo.SelectedDate.Month,
                                                                                             selectedDateInfo.SelectedDate.Day);
                }
                else
                {
                    //データ読み込み（データファイルが存在する場合）
                    (models["MonthContentsModel"] as MonthContentsModel).getMonthData(filePathBuilder,
                                                                                         selectedDateInfo.SelectedDate.Year,
                                                                                         selectedDateInfo.SelectedDate.Month,
                                                                                         selectedDateInfo.SelectedDate.Day);
                    
                }


                base.notify(this);
                
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
            finally
            {
                models["MonthContentsModel"] = null;
            }
        }
    }
}
