﻿using System;
using System.Windows.Controls;
using System.Windows.Data;
using HealthyHitsujiWpf.Model.View;

namespace HealthyHitsujiWpf.Validation
{
    class EntryViewValidationGroupClass : ValidationRule
    {
        protected readonly String intValueValidationErrorMessage_ = "数値へ変換可能な値を入力してください。";

        public override ValidationResult Validate(object value, 
                                                  System.Globalization.CultureInfo cultureInfo)
        {
            EntryViewModel viewModel = (EntryViewModel)(value as BindingGroup).Items[0];
            if (check(viewModel))
            {
                return new ValidationResult(true, null);
            }
            else
            {
                return new ValidationResult(false, intValueValidationErrorMessage_);
            }
        }

        public static Boolean check(EntryViewModel viewModel)
        {
            int intDefValue = 0;
            if (int.TryParse(viewModel.DateContentsInfo.calAm, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.calNoon, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.calPm, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.calOther, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.calBurn, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.walkCount, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.heightCm, out intDefValue) ||
                int.TryParse(viewModel.DateContentsInfo.weightKg, out intDefValue))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
