﻿using System;
using System.Windows;
using HealthyHitsujiWpf.Model.View;

namespace HealthyHitsujiWpf
{
    /// <summary>
    /// Window1.xaml の相互作用ロジック
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        public _AViewModel RootVM
        {
            get;
            set;
        }

         
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                
                //【ViewModel生成】
                RootVM = new HealthyHitsujiWpf.Model.View.RootViewModel();
                var calendarVM = new HealthyHitsujiWpf.Model.View.CalendarViewModel();
                var entryVM = new HealthyHitsujiWpf.Model.View.EntryViewModel();
                var outPutViewModel = new HealthyHitsujiWpf.Model.View.OutPutViewModel();

                //表示形式：リストボックス, データグリッド, リストボビュー
                var monthDataVM = new HealthyHitsujiWpf.Model.View.MonthDataListBoxViewModel();
                
                //【ViewModel管理登録】
                calendarVM.addMyselfAsViewModelMember(RootVM);
                entryVM.addMyselfAsViewModelMember(RootVM);
                outPutViewModel.addMyselfAsViewModelMember(RootVM);
                monthDataVM.addMyselfAsViewModelMember(RootVM);
                
                //【Window1を参照（ＵＩ更新時のディスパッチ用）】
                RootVM.BaseUiWindow = this;


                //【ViewModelとViewの関連付け（参照：V -> VM）】
                this.CalenderV.DataContext = RootVM.getViewModelMember("CalendarViewModel");
                this.EntryV.DataContext = RootVM.getViewModelMember("EntryViewModel");
                this.OutputV.DataContext = RootVM.getViewModelMember("OutPutViewModel");
                this.MonthDataListBoxV.DataContext = RootVM.getViewModelMember("MonthDataListBoxViewModel");
                
                //【初期日付セット】
                (CalenderV.DataContext as CalendarViewModel).SelectedDateData.SelectedDate = DateTime.Today;
                
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }
    }
}
